#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "person.h"
#include "personio.h"


/* Parse line for personal data, and enter it into person.
 * Return 1 iff success, 0 otherwise
 */
int line2person(person_t* person, char *line)
{
    char   *pline, *colon;

    colon = strchr(line, ':');
    if (!colon)
    {
        fprintf(stderr, "Bad line: %s\n", line);
        return 0;
    }
    *colon = '\0'; /* null terminate the name */
    person->name = malloc(strlen(line) + 1);
    strcpy(person->name, line);

    pline = colon + 1;
    person->numeric_id = strtol(pline, 0, 0);
    colon = strchr(pline, ':');
    if (!colon)
    {
        fprintf(stderr, "Bad line: %s\n", line);
        return 0;
    }

    pline = colon + 1;
    person->weight = strtod(pline, 0);
    return 1;
} /* add_person */


void person2line(char *line, person_t *p)
{
    sprintf(line, "%s:%d:%f", p->name, p->numeric_id, p->weight);
}
